

// include the library code:
#include <LiquidCrystal.h> // initialize the library with the numbers of the interface pins - The numbers
//are the pin connected in sequence from RS to DB7

//#include <SimpleRotary.h>
#include <EEPROM.h>
#include <avdweb_Switch.h>




LiquidCrystal lcd(9, 8, 7, 6, 5, 4);
//SimpleRotary rotary(2,3,0);

static int pinA = 2; // Our first hardware interrupt pin is digital pin 2
static int pinB = 3; // Our second hardware interrupt pin is digital pin 3
volatile byte aFlag = 0; // let's us know when we're expecting a rising edge on pinA to signal that the encoder has arrived at a detent
volatile byte bFlag = 0; // let's us know when we're expecting a rising edge on pinB to signal that the encoder has arrived at a detent (opposite direction to when aFlag is set)
volatile byte encoderPos = 0; //this variable stores our current value of encoder position. Change to int or uin16_t instead of byte if you want to record a larger range than 0-255
volatile byte oldEncPos = 0; //stores the last encoder position value so we can compare to the current reading and see if it has changed (so we know when to print to the serial monitor)
volatile byte reading = 0; //somewhere to store the direct values we read from our interrupt pins before checking to see if we have moved a whole detent


/** the current address in the EEPROM (i.e. which byte we're going to write to next) **/
int addr = 0;
int num=100;

int c=0;
byte r,t,l,re=0;
int pwmm=10;
int pot=A0;
float cd=0;
int ek,temp, prevtemp=0;
bool kill=false;

const byte alleventsButtonpin = 0;
Switch alleventsButton = Switch(alleventsButtonpin);

float ftemp=0.0;

unsigned long previousMillis = 0;        // will store last time LED was updated
const long interval = 1000;           // interval at which to blink (milliseconds)

float fIntegralTerm =0.0;
float fTimeSampling;
//float fTimeLast;
float fEk_1 = 0.0; //last error
const float fKp = 10.0; //proportional gian (Value tested with HQ Soldering Iron = 10 )
const float fKi = 1.0; //integral gian (Value tested with HQ Soldering Iron = 1)
const float fKd = 10.0; //derivative gian (Value tested with HQ Soldering Iron = 10)
byte PIDI=1; // 1=PID on; 0=PID off;
float fPWM; //output PWM
 
void setup() 
{
    // set up the LCD's number of columns and rows:
   lcd.begin(16, 2);
   pinMode(pwmm,OUTPUT);
   pinMode(pot,INPUT);
 
   //flsb=5.0/1024.0;
   //fscale = ( 1.0 / fAmplification ) / fKTypeSensitivity;

  pinMode(pinA, INPUT_PULLUP); // set pinA as an input, pulled HIGH to the logic voltage (5V or 3.3V for most cases)
  pinMode(pinB, INPUT_PULLUP); // set pinB as an input, pulled HIGH to the logic voltage (5V or 3.3V for most cases)
  attachInterrupt(0,PinA,RISING); // set an interrupt on PinA, looking for a rising edge signal and executing the "PinA" Interrupt Service Routine (below)
  attachInterrupt(1,PinB,RISING); // set an interrupt on PinB, looking for a rising edge signal and executing the "PinB" Interrupt Service Routine (below)
  
}


void PinA(){
  cli(); //stop interrupts happening before we read pin values
  reading = PIND & 0xC; // read all eight pin values then strip away all but pinA and pinB's values
  if(reading == B00001100 && aFlag) { //check that we have both pins at detent (HIGH) and that we are expecting detent on this pin's rising edge
    encoderPos --; //decrement the encoder's position count
    bFlag = 0; //reset flags for the next turn
    aFlag = 0; //reset flags for the next turn
  }
  else if (reading == B00000100) bFlag = 1; //signal that we're expecting pinB to signal the transition to detent from free rotation
  sei(); //restart interrupts
}

void PinB(){
  cli(); //stop interrupts happening before we read pin values
  reading = PIND & 0xC; //read all eight pin values then strip away all but pinA and pinB's values
  if (reading == B00001100 && bFlag) { //check that we have both pins at detent (HIGH) and that we are expecting detent on this pin's rising edge
    encoderPos ++; //increment the encoder's position count
    bFlag = 0; //reset flags for the next turn
    aFlag = 0; //reset flags for the next turn
  }
  else if (reading == B00001000) aFlag = 1; //signal that we're expecting pinA to signal the transition to detent from free rotation
  sei(); //restart interrupts
}

float fLimit (float fPromenljiva, float fMax, float fMin){ //Saturation function
  if (fPromenljiva > fMax)  {  fPromenljiva = fMax ; }
  if (fPromenljiva < fMin)  {  fPromenljiva = fMin ; }
  return fPromenljiva ;
}

float fSimplePID() {
  // calculate PID command, first calculate the coeficients
  float fSimplePID;
  fIntegralTerm = fIntegralTerm + fKi * ek * fTimeSampling;
  fIntegralTerm = fLimit(fIntegralTerm, 255.0, 0.0);
  fSimplePID = fKp * ek + fIntegralTerm + fKd * (ek - fEk_1); // SimplePID
  fSimplePID = fLimit(fSimplePID, 255.0, 0.0);
  return fSimplePID;
}



void loop() {
   
   //r = rotary.rotate();  // 0 = not turning, 1 = CW, 2 = CCW
  // t = rotary.pushType(3000);   // 0 = not pushed, 1 = pushed, 2 = long pushed
  alleventsButton.poll();
  
  if(alleventsButton.doubleClick()){ t=3;} //dvojklikom vojde do menu
  
   if(oldEncPos != encoderPos) {
   if(oldEncPos>encoderPos){r=1;} //ak je nova hodnota mensia
   if(oldEncPos<encoderPos){r=2;} //ak je nova hodnota vacsia
   
    oldEncPos = encoderPos;
  }else{
    r=0;
  }

   

    if(re==0){  //nacitaj iba prvy krat po spusteni programu
      int tem=EEPROM.read(0);
      if(EEPROM.read(1)==1)tem=tem+256; //ak ma druha adresa priznak, k nacitanej hodnote pripocitaj 255
      c=tem;
      re=1;
      PIDI=EEPROM.read(2); //nacitaj ulozeny stav regulatora
    }

   
  if(t==0){  //teplotu men iba ked nie je v menu
   if ( r == 1 ){
     c=c-5;
     if(c<0)c=0;
   }
   if ( r == 2 ){
     c=c+5;
     if(c>400)c=400;
   }
  }

  if(t==0){
   if(alleventsButton.singleClick()){ 
     EEPROM.write(0, c);
     if(c>255){ //ak je teplota vyssia ako 255, na dalsiu adresu uloz priznak
       EEPROM.write(1,1);
     }else{
       EEPROM.write(1,0);
     }
     lcd.setCursor(0,0);
     lcd.print("Saved   ");
     delay(2000);
  }
  }
  

  
  if(alleventsButton.longPress()){
    lcd.setCursor(0,0);
    lcd.print("Erasing...");
    for (int i = 0 ; i < EEPROM.length() ; i++) {
      EEPROM.write(i, 0);
    }
    lcd.setCursor(0,0);
    lcd.print("Done      ");
    delay(2000);
  }


   lcd.setCursor(0, 0);
   lcd.print("S:");
   lcd.setCursor(2,0);
   lcd.print(c);
   lcd.print("  ");
   lcd.setCursor(5,0);
   //lcd.print((char)178);
   lcd.print((char)223);
   lcd.setCursor(6,0);
   lcd.print("C");
   lcd.setCursor(7,0);

   if(t==3){ //si v menu
     lcd.setCursor(8,0);
     lcd.print("Control");    
   }else{
     lcd.print("         ");
   }
   
   lcd.setCursor(0,1);
   lcd.print("T:");


   //meranie spravi raz za urceny interval
   unsigned long currentMillis = millis();

   if (currentMillis - previousMillis >= interval) {
    previousMillis = currentMillis;
   
    for(int i=1; i<=num; i++){
     cd=cd + analogRead(pot); 
    // delay(1);
    }
    cd=cd/num;
    ftemp=cd/2.5;
    temp=(int)ftemp;

    if(prevtemp>0){     //teplota skocila o viac ako 20 stupnov hore alebo dole (problem so snimacom alebo vystupnym tranzistorom)
        int roz=prevtemp-temp; //rozdiel predchadzajuca teplota - nova teplota
        if(abs(roz)>20){
           kill=true;
        }else{
           kill=false;
           prevtemp=temp;
        }
    }else{
      prevtemp=temp;
    }
   }


   lcd.setCursor(2,1);
   lcd.print(temp);
   lcd.print("  ");
   lcd.setCursor(5,1);
   //lcd.print((char)178);
   lcd.print((char)223);
   lcd.setCursor(6,1);
   lcd.print("C");
   lcd.setCursor(7,1);
  

   //jednoduche menu na vyber regulatora
   if(t==3){

     if(r==1 || r==2){ //ak otoci enkoderom do ktorejkolvek strany
       if(PIDI==0){PIDI=1;}else{PIDI=0;}
     }
     if(PIDI==0){lcd.setCursor(8,1);lcd.print("ON/OFF");}
     if(PIDI==1){lcd.setCursor(8,1);lcd.print("PID   ");}
     
    if(alleventsButton.singleClick()){
     //uloz do eeprom
     EEPROM.write(2,PIDI);
     t=0;
    }
   }else{
   lcd.print("          ");
   }

   
   ek=c-temp; //rozdiel nastavena teplota - skutocna teplota

   if(!kill){
    if(PIDI==0){  //PID is off
     if(ek<3){analogWrite(pwmm,0);}
     else{
      analogWrite(pwmm,255);
     }
    }

    if(PIDI==1){ //PID is on
     fPWM = fSimplePID(); //calculate PID command
     fEk_1 = ek;
     analogWrite(pwmm, fPWM);  //execute the command
    }
   }else{
    analogWrite(pwmm,0);
   }

   if(kill){
    tone(12,1000);
   }else{
    noTone(12);
   }
  
  
    
  
}
